commit 57a74ec9410d6700432b6909da08d8d319cf65e2
Author: Amos Benari <abenari@redhat.com>
Date:   Tue May 1 16:27:11 2012 +0300

    added ace code editor to the provisioning template edit page.
    
    added info text to the assosiation tab of the provisioning templates page.

diff --git a/app/views/config_templates/_form.html.erb b/app/views/config_templates/_form.html.erb
index c05068c64..5ddf5bb5d 100644
--- a/app/views/config_templates/_form.html.erb
+++ b/app/views/config_templates/_form.html.erb
@@ -1,22 +1,51 @@
+<%= javascript 'config_template', 'ace/ace', 'ace/theme-twilight', 'ace/theme-dawn','ace/mode-ruby' %>
 <%= form_for @config_template, :html => { :multipart => true } do |f| %>
   <%= base_errors_for @config_template %>
-  <%= text_f f, :name %>
-  <%= checkbox_f f, :snippet, :onchange => "$('#kind_selector, #template_associations').toggle(!$('#config_template_snippet').attr('checked'))" %>
+  <ul class="nav nav-tabs" data-tabs="tabs">
+    <li class="active"><a href="#primary" data-toggle="tab">Primary</a></li>
+    <li><a href="#template_associations" data-toggle="tab">Association</a></li>
+  </ul>
 
-  <div id="kind_selector" <%= display? @config_template.snippet %>>
-    <%= select_f f, :template_kind_id, TemplateKind.all, :id, :name, :include_blank => true, :label => "Type" %>
- </div>
+  <div class="tab-content">
+    <div class="tab-pane active" id="primary">
+      <%= text_f f, :name %>
+      <%= checkbox_f f, :snippet, :onchange => "snippet_changed(this)" %>
 
- <%= textarea_f f, :template, :class => "input-xxlarge",
-   :help_block =>"<span class='label label-info'>Notice</span> #{link_to 'Useful template functions and macros', 'http://theforeman.org/projects/foreman/wiki/TemplateWriting#Functions-and-macros',
-     :rel => "external"}".html_safe
-   %>
- <%= file_field_f f, :template, :help_inline => "<span class='label label-info'>upload</span> a template instead".html_safe %>
+      <div id="kind_selector" <%= display? @config_template.snippet %>>
+        <%= select_f f, :template_kind_id, TemplateKind.all, :id, :name, :include_blank => true, :label => "Type" %>
+      </div>
 
- <div id="template_associations" <%= display? @config_template.snippet %>>
-   <%= multiple_checkboxes f, :operatingsystems, @config_template, Operatingsystem, :label => "Operating Systems" %>
-   <%= render "combinations", :f => f %>
+      <%= textarea_f f, :template, :class => "span10 template_text", :label=>"Template editor",
+        :help_block =>"<i class='icon-info-sign'></i> Notice #{link_to 'Useful template functions and macros', 'http://theforeman.org/projects/foreman/wiki/TemplateWriting#Functions-and-macros',
+        :rel => "external"}".html_safe
+      %>
+      <%= file_field_f f, :template,:class => "template_file btn span4",
+                       :help_inline => "<a class='label label-important clear_file' title='clear file selection'>&times<a>".html_safe,
+                       :help_block => "<i class='icon-info-sign'></i> Selecting a file will override the editor and load the file instead".html_safe %>
+   </div>
+   <div class="tab-pane" id="template_associations">
+     <p id="snippet_message" class="alert alert-message" <%=  display? !@config_template.snippet%> >Not relevant for snippet</p>
+     <div id="association" <%=  display? @config_template.snippet%> >
+     <div class="alert alert-message alert-success">
+        <a class="close" href="#" data-dismiss="alert">&times;</a>
+        <h3>How Templates are determined<br></h3>
+        <p>When editing a Template, you must assign a list of Operating Systems which this
+        Template can be used with. Optionally, you can restrict a template to a list of
+        Hostgroups and/or Environments</p>
+        <p>When a Host requests a template (e.g. during provisioning), Foreman will select
+        the best match from the available templates of that type, in the following order:</p>
+        <ul>
+          <li>Host-group and Environment</li>
+          <li>Host-group only</li>
+          <li>Environment only</li>
+          <li>Operating system default</li>
+        </ul>
+        The final entry, Operating System default, can be set by editing the <%= link_to "Operating System", operatingsystems_path %> page.
+     </div>
+       <%= multiple_checkboxes f, :operatingsystems, @config_template, Operatingsystem, :label => "Applicable<br>Operating Systems".html_safe%>
+       <%= render "combinations", :f => f %>
+     </div>
+   </div>
  </div>
-
  <%= submit_or_cancel f %>
 <% end %>
diff --git a/public/javascripts/config_template.js b/public/javascripts/config_template.js
new file mode 100644
index 000000000..a7decdb79
--- /dev/null
+++ b/public/javascripts/config_template.js
@@ -0,0 +1,50 @@
+
+function snippet_changed(item){
+  var checked = !!$(item).attr('checked');
+  $('#kind_selector').toggle(!checked);
+  $('#snippet_message').toggle(checked);
+  $('#association').toggle(!checked);
+}
+$(function() {
+  var text_area = $(".template_text");
+  text_area.parent().prepend("<div id='editor1'></div>");
+
+  $("#editor1")
+      .css("position","relative")
+      .height(text_area.height())
+      .width(text_area.width());
+  text_area.hide();
+
+  var editor = ace.edit("editor1");
+  editor.setTheme("ace/theme/twilight");
+  editor.setShowPrintMargin(false);
+  editor.renderer.setShowGutter(false);
+
+  var RubyMode = require("ace/mode/ruby").Mode;
+  var session = editor.getSession();
+  session.setMode(new RubyMode());
+//  session.setUseWrapMode(true);
+
+  var content = text_area.text();
+  session.setValue(content);
+  session.on('change', function(){
+    text_area.text(session.getValue());
+  });
+
+  $(".template_file").on("change", function(){
+      if ($(".template_file").val() != ""){
+        editor.setReadOnly(true);
+        editor.setTheme("ace/theme/dawn");
+        $(".template_file").addClass('btn-inverse');
+      }
+  })
+
+  $(".clear_file").on("click", function(){
+      $(".template_file").val("");
+      editor.setReadOnly(false);
+      editor.setTheme("ace/theme/twilight");
+      $(".template_file").removeClass('btn-inverse');
+      false;
+  })
+})
+
